commit:     2e29157e8acb1c2750139326314e527ee0235774
Author:     Meena Shanmugam <meenashanmugam <AT> google <DOT> com>
AuthorDate: Thu Mar 17 21:54:47 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Mon Mar 21 23:38:48 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=2e29157e

app-editors/gvim: version bump to v8.2.4586.

This is needed to resolve CVE-2022-0714, CVE-2022-0696, CVE-2022-0685,
CVE-2022-0729, CVE-2022-0572 and CVE-2022-0629.

Bug: https://bugs.gentoo.org/833572
Signed-off-by: Meena Shanmugam <meenashanmugam <AT> google.com>
Closes: https://github.com/gentoo/gentoo/pull/24629
Signed-off-by: Sam James <sam <AT> gentoo.org>

 app-editors/gvim/Manifest             |   1 +
 app-editors/gvim/gvim-8.2.4586.ebuild | 383 ++++++++++++++++++++++++++++++++++
 2 files changed, 384 insertions(+)

diff --git a/app-editors/gvim/Manifest b/app-editors/gvim/Manifest
index 30ebf269d61f..ed4d92456abb 100644
--- a/app-editors/gvim/Manifest
+++ b/app-editors/gvim/Manifest
@@ -8,3 +8,4 @@ DIST vim-8.2.3741.tar.gz 15812097 BLAKE2B 
5cd90d4c86774a63a020ac8f245005e3f7df03
 DIST vim-8.2.3950.tar.gz 15865929 BLAKE2B 
e713895f847194845c1a794fc796e97678b11686f51f9a33898d92cf1d3927c6d49cd24024b6c5cbbad82b45ab8293f6d4663f14e66a56cc8b361a5fabdbb0b0
 SHA512 
d9176f74a1b753fb9118362350b3da16f176c7bc5cc57b41dab1f470c1e80830e4a6f4851d5a090d6efdb272186bd8f6a8a5e08e5da5ae0474560cb32dd626be
 DIST vim-8.2.4285.tar.gz 15962343 BLAKE2B 
ba0971cbea3d3fe1761961f66a24281c06f0a509f1aac7c32e26f07b5d9d122b72da68646874b1f20879372d26e1b5a72f020913a31c1c0aa26f8e6bff074516
 SHA512 
760180b89c285b92f3ec40041c784e756a93d7c6d75386c1c737762b9041babfaa17fd0b9e47e3e4298b24b8f5c7300e6a1ab2addbbcda94e46c973a97d578ec
 DIST vim-8.2.4328.tar.gz 15983756 BLAKE2B 
23d95d2ae6772fbd2a15a73dff5af75dcebf87af5a6a600d8a30284d32d1f83999111bfaa0e49c0295ae42a06f49075aeb00f8ae969eff251889b363b7445fda
 SHA512 
f5e077891d22f468327e30808dba817efe74111c89948fbea5544be58333a8d3342290fa140939dd9c7d976575e63050e100daf947ba73373cc2268677020651
+DIST vim-8.2.4586.tar.gz 16251186 BLAKE2B 
26471b493397e58d3e3d6f2c0c5cc69a08c294dcd59367a12729d1762cf2043eab0987ec4c370bd1f4cbbc67d10576f8a6dcfcb748d224b2f35476dbade32597
 SHA512 
354464e51a3cc13e13f3194ef8a4d5ccec978da7eb385337a042a6b2e6b38a253c587815e7c972070c516f59c7d54c89bce6926ae7f7f9635cddfd1d0bd237b9

diff --git a/app-editors/gvim/gvim-8.2.4586.ebuild 
b/app-editors/gvim/gvim-8.2.4586.ebuild
new file mode 100644
index 000000000000..3600cac317cd
--- /dev/null
+++ b/app-editors/gvim/gvim-8.2.4586.ebuild
@@ -0,0 +1,383 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+# Please bump with app-editors/vim-core and app-editors/gvim
+
+VIM_VERSION="8.2"
+LUA_COMPAT=( lua5-1 luajit )
+PYTHON_COMPAT=( python3_{7..10} )
+PYTHON_REQ_USE="threads(+)"
+USE_RUBY="ruby24 ruby25 ruby26 ruby27"
+
+inherit vim-doc flag-o-matic xdg-utils bash-completion-r1 prefix lua-single 
python-single-r1 ruby-single
+
+if [[ ${PV} == 9999* ]]; then
+       inherit git-r3
+       EGIT_REPO_URI="https://github.com/vim/vim.git";
+       EGIT_CHECKOUT_DIR=${WORKDIR}/vim-${PV}
+else
+       SRC_URI="https://github.com/vim/vim/archive/v${PV}.tar.gz -> 
vim-${PV}.tar.gz
+               
https://dev.gentoo.org/~zlogene/distfiles/app-editors/vim/vim-8.2.0360-gentoo-patches.tar.xz";
+       KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~ppc ~ppc64 ~riscv 
~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~ppc-macos ~x86-solaris"
+fi
+S="${WORKDIR}"/vim-${PV}
+
+DESCRIPTION="GUI version of the Vim text editor"
+HOMEPAGE="https://vim.sourceforge.io/ https://github.com/vim/vim";
+
+LICENSE="vim"
+SLOT="0"
+IUSE="acl aqua crypt cscope debug gtk gtk2 lua motif neXt netbeans nls perl 
python racket ruby selinux session sound tcl"
+REQUIRED_USE="
+       lua? ( ${LUA_REQUIRED_USE} )
+       python? ( ${PYTHON_REQUIRED_USE} )
+"
+
+RDEPEND="
+       ~app-editors/vim-core-${PV}
+       >=app-eselect/eselect-vi-1.1
+       >=sys-libs/ncurses-5.2-r2:0=
+       x11-libs/libICE
+       x11-libs/libSM
+       x11-libs/libXext
+       x11-libs/libXt
+       acl? ( kernel_linux? ( sys-apps/acl ) )
+       !aqua? (
+               gtk? (
+                       x11-libs/gtk+:3
+                       x11-libs/libXft
+               )
+               !gtk? (
+                       gtk2? (
+                               >=x11-libs/gtk+-2.6:2
+                               x11-libs/libXft
+                       )
+                       !gtk2? (
+                               motif? ( >=x11-libs/motif-2.3:0 )
+                               !motif? (
+                                       neXt? ( x11-libs/neXtaw )
+                                       !neXt? ( x11-libs/libXaw )
+                               )
+                       )
+               )
+       )
+       crypt? ( dev-libs/libsodium:= )
+       cscope? ( dev-util/cscope )
+       lua? (
+               ${LUA_DEPS}
+               $(lua_gen_impl_dep 'deprecated' lua5-1)
+       )
+       nls? ( virtual/libintl )
+       perl? ( dev-lang/perl:= )
+       python? ( ${PYTHON_DEPS} )
+       racket? ( dev-scheme/racket )
+       ruby? ( ${RUBY_DEPS} )
+       selinux? ( sys-libs/libselinux )
+       session? ( x11-libs/libSM )
+       sound? ( media-libs/libcanberra )
+       tcl? ( dev-lang/tcl:0= )
+"
+DEPEND="${RDEPEND}"
+# configure runs the Lua interpreter
+BDEPEND="
+       sys-devel/autoconf
+       virtual/pkgconfig
+       lua? ( ${LUA_DEPS} )
+       nls? ( sys-devel/gettext )
+"
+
+# various failures (bugs #630042 and #682320)
+RESTRICT="test"
+
+pkg_setup() {
+       # people with broken alphabets run into trouble. bug 82186.
+       unset LANG LC_ALL
+       export LC_COLLATE="C"
+
+       # Gnome sandbox silliness. bug #114475.
+       mkdir -p "${T}"/home || die
+       export HOME="${T}"/home
+
+       use lua && lua-single_pkg_setup
+       use python && python-single-r1_pkg_setup
+}
+
+src_prepare() {
+       if [[ ${PV} != 9999* ]]; then
+               # Gentoo patches to fix runtime issues, cross-compile errors, 
etc
+               eapply "${WORKDIR}"/patches/
+       fi
+
+       # Fixup a script to use awk instead of nawk
+       sed -i -e \
+               '1s|.*|#!'"${EPREFIX}"'/usr/bin/awk -f|' \
+               "${S}"/runtime/tools/mve.awk || die "mve.awk sed failed"
+
+       # Read vimrc and gvimrc from /etc/vim
+       echo '#define SYS_VIMRC_FILE "'${EPREFIX}'/etc/vim/vimrc"' \
+           >> "${S}"/src/feature.h || die "echo failed"
+       echo '#define SYS_GVIMRC_FILE "'${EPREFIX}'/etc/vim/gvimrc"' \
+           >> "${S}"/src/feature.h || die "echo failed"
+
+       # Use exuberant ctags which installs as /usr/bin/exuberant-ctags.
+       # Hopefully this pattern won't break for a while at least.
+       # This fixes bug 29398 (27 Sep 2003 agriffis)
+       sed -i -e \
+               's/\<ctags\("\| [-*.]\)/exuberant-&/g' \
+               "${S}"/runtime/doc/syntax.txt \
+               "${S}"/runtime/doc/tagsrch.txt \
+               "${S}"/runtime/doc/usr_29.txt \
+               "${S}"/runtime/menu.vim \
+               "${S}"/src/configure.ac || die 'sed failed'
+
+       # Don't be fooled by /usr/include/libc.h.  When found, vim thinks
+       # this is NeXT, but it's actually just a file in dev-libs/9libs
+       # This fixes bug 43885 (20 Mar 2004 agriffis)
+       sed -i -e \
+               's/ libc\.h / /' "${S}"/src/configure.ac || die 'sed failed'
+
+       # gcc on sparc32 has this, uhm, interesting problem with detecting EOF
+       # correctly. To avoid some really entertaining error messages about 
stuff
+       # which isn't even in the source file being invalid, we'll do some 
trickery
+       # to make the error never occur. bug 66162 (02 October 2004 ciaranm)
+       find "${S}" -name '*.c' | while read c; do
+           echo >> "$c" || die "echo failed"
+       done
+
+       # Try to avoid sandbox problems. Bug #114475.
+       if [[ -d "${S}"/src/po ]]; then
+               sed -i -e \
+                       '/-S check.vim/s,..VIM.,ln -s $(VIM) testvim \; 
./testvim -X,' \
+                       "${S}"/src/po/Makefile || die
+       fi
+
+       cp -v "${S}"/src/config.mk.dist "${S}"/src/auto/config.mk || die "cp 
failed"
+
+       # Bug #378107 - Build properly with >=perl-core/ExtUtils-ParseXS-3.20.0
+       sed -i -e \
+               "s:\\\$(PERLLIB)/ExtUtils/xsubpp:${EPREFIX}/usr/bin/xsubpp:" \
+               "${S}"/src/Makefile || die 'sed for ExtUtils-ParseXS failed'
+
+       eapply_user
+}
+
+src_configure() {
+       local myconf=()
+
+       # Fix bug 37354: Disallow -funroll-all-loops on amd64
+       # Bug 57859 suggests that we want to do this for all archs
+       filter-flags -funroll-all-loops
+
+       # Fix bug 76331: -O3 causes problems, use -O2 instead. We'll do this for
+       # everyone since previous flag filtering bugs have turned out to affect
+       # multiple archs...
+       replace-flags -O3 -O2
+
+       # Fix bug 18245: Prevent "make" from the following chain:
+       # (1) Notice configure.ac is newer than auto/configure
+       # (2) Rebuild auto/configure
+       # (3) Notice auto/configure is newer than auto/config.mk
+       # (4) Run ./configure (with wrong args) to remake auto/config.mk
+       sed -i -e \
+               's# auto/config\.mk:#:#' src/Makefile || die "Makefile sed 
failed"
+       rm -v src/auto/configure || die "rm failed"
+       emake -j1 -C src autoconf
+
+       # This should fix a sandbox violation (see bug 24447). The hvc
+       # things are for ppc64, see bug 86433.
+       local file
+       for file in /dev/pty/s* /dev/console /dev/hvc/* /dev/hvc*; do
+               if [[ -e ${file} ]]; then
+                       addwrite $file
+               fi
+       done
+
+       use debug && append-flags "-DDEBUG"
+
+       myconf=(
+               --with-features=huge
+               --disable-gpm
+               --with-gnome=no
+               $(use_enable sound canberra)
+               $(use_enable acl)
+               $(use_enable crypt libsodium)
+               $(use_enable cscope)
+               $(use_enable netbeans)
+               $(use_enable nls)
+               $(use_enable perl perlinterp)
+               $(use_enable python python3interp)
+               $(use_with python python3-command "${PYTHON}")
+               $(use_enable racket mzschemeinterp)
+               $(use_enable ruby rubyinterp)
+               $(use_enable selinux)
+               $(use_enable session xsmp)
+               $(use_enable tcl tclinterp)
+       )
+
+       # --with-features=huge forces on cscope even if we --disable it. We need
+       # to sed this out to avoid screwiness. (1 Sep 2004 ciaranm)
+       if ! use cscope; then
+               sed -i -e \
+                       '/# define FEAT_CSCOPE/d' src/feature.h || die 
"couldn't disable cscope"
+       fi
+
+       if use lua; then
+               myconf+=(
+                       --enable-luainterp
+                       $(use_with lua_single_target_luajit luajit)
+                       --with-lua-prefix="${EPREFIX}/usr"
+               )
+       fi
+
+       # gvim's GUI preference order is as follows:
+       # aqua                         CARBON (not tested)
+       # -aqua gtk                    GTK3
+       # -aqua -gtk gtk2              GTK2
+       # -aqua -gtk -gtk motif        MOTIF
+       # -aqua -gtk -gtk -motif neXt  NEXTAW
+       # -aqua -gtk -gtk -motif -neXt ATHENA
+       echo ; echo
+       if use aqua; then
+               einfo "Building gvim with the Carbon GUI"
+               myconf+=(
+                       --enable-darwin
+                       --enable-gui=carbon
+               )
+       elif use gtk; then
+               myconf+=( --enable-gtk3-check )
+               einfo "Building gvim with the gtk+-3 GUI"
+               myconf+=( --enable-gui=gtk3 )
+       elif use gtk2; then
+               myconf+=( --enable-gtk2-check )
+               einfo "Building gvim with the gtk+-2 GUI"
+               myconf+=( --enable-gui=gtk2 )
+       elif use motif; then
+               einfo "Building gvim with the MOTIF GUI"
+               myconf+=( --enable-gui=motif )
+       elif use neXt; then
+               einfo "Building gvim with the neXtaw GUI"
+               myconf+=( --enable-gui=nextaw )
+       else
+               einfo "Building gvim with the Athena GUI"
+               myconf+=( --enable-gui=athena )
+       fi
+       echo ; echo
+
+       # let package manager strip binaries
+       export ac_cv_prog_STRIP="$(type -P true ) faking strip"
+
+       # keep prefix env contained within the EPREFIX
+       use prefix && myconf+=( --without-local-dir )
+
+       if [[ ${CHOST} == *-interix* ]]; then
+               # avoid finding of this function, to avoid having to patch 
either
+               # configure or the source, which would be much more hackish.
+               # after all vim does it right, only interix is badly broken 
(again)
+               export ac_cv_func_sigaction=no
+       fi
+
+       econf \
+               --with-modified-by=Gentoo-${PVR} \
+               --with-vim-name=gvim \
+               --with-x \
+               "${myconf[@]}"
+}
+
+src_compile() {
+       # The following allows emake to be used
+       emake -j1 -C src auto/osdef.h objects
+
+       emake
+}
+
+src_test() {
+       einfo
+       einfo "Starting vim tests. Several error messages will be shown"
+       einfo "while the tests run. This is normal behaviour and does not"
+       einfo "indicate a fault."
+       einfo
+       ewarn "If the tests fail, your terminal may be left in a strange"
+       ewarn "state. Usually, running 'reset' will fix this."
+       einfo
+
+       # Don't let vim talk to X
+       unset DISPLAY
+
+       # Make gvim not try to connect to X. See :help gui-x11-start in vim for 
how
+       # this evil trickery works.
+       ln -s "${S}"/src/gvim "${S}"/src/testvim || die
+
+       # Make sure our VIMPROG is used.
+       sed -i -e 's:\.\./vim:../testvim:' src/testdir/test49.vim || die
+
+       # Don't do additional GUI tests.
+       emake -j1 VIMPROG=../testvim -C src/testdir nongui
+}
+
+# Call eselect vi update with --if-unset
+# to respect user's choice (bug 187449)
+eselect_vi_update() {
+       einfo "Calling eselect vi update..."
+       eselect vi update --if-unset
+       eend $?
+}
+
+src_install() {
+       local vimfiles=/usr/share/vim/vim${VIM_VERSION/.}
+
+       dobin src/gvim
+       dosym gvim /usr/bin/gvimdiff
+       dosym gvim /usr/bin/evim
+       dosym gvim /usr/bin/eview
+       dosym gvim /usr/bin/gview
+       dosym gvim /usr/bin/rgvim
+       dosym gvim /usr/bin/rgview
+
+       emake -C src DESTDIR="${D}" DATADIR="${EPREFIX}"/usr/share install-icons
+
+       dodir /usr/share/man/man1
+       echo ".so vim.1" > "${ED}"/usr/share/man/man1/gvim.1 || die "echo 
failed"
+       echo ".so vim.1" > "${ED}"/usr/share/man/man1/gview.1 || die "echo 
failed"
+       echo ".so vimdiff.1" > "${ED}"/usr/share/man/man1/gvimdiff.1 || \
+               die "echo failed"
+
+       insinto /etc/vim
+       newins "${FILESDIR}"/gvimrc-r1 gvimrc
+       eprefixify "${ED}"/etc/vim/gvimrc
+
+       # bash completion script, bug #79018.
+       newbashcomp "${FILESDIR}"/${PN}-completion ${PN}
+
+       # don't install vim desktop file
+       rm -v "${ED}"/usr/share/applications/vim.desktop || die "failed to 
remove vim.desktop"
+}
+
+pkg_postinst() {
+       # update documentation tags (from vim-doc.eclass)
+       update_vim_helptags
+
+       # update fdo mime stuff, bug #78394
+       xdg_desktop_database_update
+
+       # update icon cache
+       xdg_icon_cache_update
+
+       # call eselect vi update
+       eselect_vi_update
+}
+
+pkg_postrm() {
+       # update documentation tags (from vim-doc.eclass)
+       update_vim_helptags
+
+       # update fdo mime stuff, bug #78394
+       xdg_desktop_database_update
+
+       # update icon cache
+       xdg_icon_cache_update
+
+       # call eselect vi update
+       eselect_vi_update
+}

Reply via email to